#ifndef LDAP2VOCALUSER_HXX_
#define LDAP2VOCALUSER_HXX_

/* ====================================================================
 * The Vovida Software License, Version 1.0
 *
 * Copyright (c) 1999, 2000 Vovida Networks, Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The end-user documentation included with the redistribution,
 *    if any, must include the following acknowledgment:
 *       "This product includes software developed by Vovida Networks,
 *        Inc. (http://www.vovida.org/)."
 *    Alternately, this acknowledgment may appear in the software itself,
 *    if and wherever such third-party acknowledgments normally appear.
 *
 * 4. The names "VOCAL", "Vovida Open Communication Application Library",
 *    and "Vovida Open Communication Application Library (VOCAL)" must 
 *    not be used to endorse or promote products derived from this 
 *    software without prior written permission. For written permission, 
 *    please contact vocal@vovida.org.
 *
 * 5. Products derived from this software may not be called "VOCAL",
 *    nor may "VOCAL" appear in their name, without prior written
 *    permission of Vovida Networks, Inc.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL VOVIDA NETWORKS, INC. OR ITS 
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * ====================================================================
 *
 * This software consists of voluntary contributions made by Vovida 
 * Networks, Inc. and many individuals on behalf of Vovida Networks,
 * Inc.  For more information on Vovida Networks, Inc., please see 
 * <http://www.vovida.org/>.
 *
 */

/* Authors: Eddie Mendonca
*/

/* Includes */
#include <stdio.h>
#include <string.h>
#include <strstream.h>

#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <dirent.h>

#include <getopt.h>
#include <lber.h>
#include <ldap.h>

#include <iostream>
#include <cassert>
#include <FileDataStore.hxx>
#include <VIoException.hxx>

/* Conditional Constants */
#ifdef LDAP_OPT_SIZELIMIT   /* Netscape SDK */
#define GET_LDERROR(ld)     ldap_get_lderrno ((ld), NULL, NULL)
#define MEM_FREE(ld)        ldap_memfree ((ld))
#else                       /* OpenLDAP SDK */
#define GET_LDERROR(ld)     (ld)->ld_errno
#define MEM_FREE(ld)        free ((ld))
#endif

/* LDAP Attributes */
#define ATTR_TELEPHONENUMBER         "telephonenumber"
#define ATTR_VOCAL_PHONENUMBER       "vocalphonenumber"
#define ATTR_VOCAL_IP                "vocalip"
#define ATTR_VOCAL_FNA               "vocalfna"
#define ATTR_VOCAL_CFB               "vocalcfb"

/* Misc Constants */
#define SEARCH_FILTER                "(objectclass=*)"
#define MAX_ATTR_STRING              256
#define MAX_FILE_SIZE                10000
#define HASH_KEY                     6
#define DIR_PERMISSIONS              0750
#define ACCOUNTS_GROUP               "Accounts"

/* Substitude these if attribute not found in LDAP */
#define PHONE_NOT_IN_LDAP            "nonumber@mycompany.com"
#define IP_NOT_IN_LDAP               "xxx.xxx.xxx.xxx"
#define FNA_NOT_IN_LDAP              "1111"
#define CFB_NOT_IN_LDAP              "2222"

#endif
