#!/usr/bin/perl -w
#
# script to generate x number of user accounts
#
# Usage: genUsers begin-userid num-users
#
# Copyright 2000 by Wendy Breu 
#
#
# $Id: genUsers.pl,v 1.1 2000/08/04 20:30:32 wbreu Exp $
#
#
###############################################################################
# display usage message
#
if (@ARGV != 2 ) {
  die "Usage:  $0  begin-userid num-users\n";
}

# verbose mode
$verbose = 1;

# parse arguments
$idbase = $ARGV[0];   # begin userid
$count = $ARGV[1];    # generate $count users

# set template file:
$at = "@";
$template = "/usr/local/vocal/provisioning_data/Accounts.generated/99998".$at."vovida.com.xml";

$id = $idbase;

# using $template file, generate $idbase+n@vovida.com.xml file
sub cloneAccount {

   # assume <TEMPLATE> and <OUTFILE> are already opened:
   while (<TEMPLATE>)
   {
       $line = $_;
       chomp($line);
       if (/(^<user><name>)/) {
          $newline = "<user><name>$id".$at."vovida.com</name>";
          print OUTFILE "$newline\n"; 
          printf( "newline = $newline\n" );
          next;
       }
       # ignore the rest of xml data, just output to OUTFILE:
       print OUTFILE "$line\n";
   }
}

# set up file handles to generate new user xml files:
sub prepareData {
   $outfile = "$id".$at."vovida.com.xml";
   if (-e $outfile )
   {
      rmdir $outfile;
   }

   # first, fix up the calling ua.cfg
   open( TEMPLATE, "<" . $template) || die "Could not open $template\n";
   open(OUTFILE, ">$outfile");
      print "generating $outfile...\n" if $verbose;
      cloneAccount();
   close( OUTFILE );
   close( TEMPLATE );
}

# main prog
sub main {
   # loop $count times
   $i = $count;
   while ($i) {
       prepareData();     
       $id++;
       $i--;
   }   
}

main();

## end of program
