#include <stdio.h>
#include <iostream.h>

#include "TRIPUpdateMsg.hxx"
#include "LSSessionManager.hxx"
#include "LSPeerSession.hxx"
#include "cpLog.h"

main()
{
    //TESTING ONLY
    //Create the UPdate Message
    TRIPUpdateMsg uMsg;
    Sptr<TRIPWithdrawnRoute> route1 = new TRIPWithdrawnRoute(TRIP_FLG_TRANSITIVE);
    Sptr<TRIPReachableRoute> route2 = new TRIPReachableRoute(TRIP_FLG_TRANSITIVE);
    TRIPRoutes tRoute(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1408"));
    TRIPRoutes tRoute2(TRIP_ADDR_POTS, TRIP_APP_PROTO_SIP,TRIPData("1508"));
    *route1 << tRoute;
    *route2 << tRoute2;

    uMsg.addWithdrawnRoute(route1);
    uMsg.addReachableRoute(route2);

    TRIPItadPathSegment seg1(TRIP_SEG_AP_SET, 1224);
    Sptr<TRIPAdvertisePath> aPath = new TRIPAdvertisePath(TRIP_FLG_TRANSITIVE);
    *aPath << seg1;

    TRIPItadPathSegment seg2(TRIP_SEG_AP_SET, 1224);
    Sptr<TRIPRoutedPath> aPath2 = new TRIPRoutedPath(TRIP_FLG_TRANSITIVE);
    *aPath2 << seg2;

    uMsg.addAdvertisePath(aPath); 
    uMsg.addRoutedPath(aPath2);  
    
    Sptr<TRIPNextHopServer> nServer = new TRIPNextHopServer(TRIP_FLG_TRANSITIVE, 1223,
                                                      TRIPData("129.234.34.56"));
    uMsg.addAttribute(nServer);
    
    cerr << "Update Msg:" << uMsg << endl;
    try
    {
        cpLogSetPriority(7);
        LSSessionManager& manager = LSSessionManager::instance(1234);
        manager.threadRun();
        while(1)
        {
            sleep(2);
            cerr << "Sending update" << endl;
            const LSSessionManager::LSPeerList& lsList = manager.getSessionList();
            LSSessionManager::LSPeerList::const_iterator itr;
            for(itr = lsList.begin(); itr != lsList.end(); itr++)
            {
                (*itr)->sendUpdate(uMsg);
            }
        }
    }
    catch(VException& e)
    {
        cerr << "Caught exception:" << e.getDescription().c_str() << endl;
    }

}
